#include "servoframe.h"
#include "ui_servoframe.h"

servoFrame::servoFrame(QWidget *parent) :
    QFrame(parent),
    m_ui(new Ui::servoFrame)
{
    m_ui->setupUi(this);
}

servoFrame::~servoFrame()
{
    delete m_ui;
}

void servoFrame::changeEvent(QEvent *e)
{
    QFrame::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        m_ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

QString servoFrame::id()
{
    return m_ui->nameEdit->text();
}

int servoFrame::port()
{
    return m_ui->portSpin->value();
}

int servoFrame::pos()
{
    return m_ui->positionSpin->value();
}

void servoFrame::setId(QString id)
{
    m_ui->nameEdit->setText(id);
}

void servoFrame::setPort(int port)
{
    m_ui->portSpin->setValue(port);
}

void servoFrame::setPos(int pos)
{
    m_ui->positionSpin->setValue(pos);
}

bool servoFrame::selected()
{
    return m_ui->selectedBox->isChecked();
}

void servoFrame::setSelected(bool sel)
{
    return m_ui->selectedBox->setChecked(sel);
}

void servoFrame::on_positionSpin_valueChanged(int )
{
    emit onServoChange(this->id(), this);
}

void servoFrame::on_selectedBox_toggled(bool checked)
{
    m_ui->positionDial->setEnabled(checked);
    m_ui->positionSpin->setEnabled(checked);
    if(!checked)m_ui->positionDial->setValue(0);
    emit onServoChange(this->id(),this);
}


void servoFrame::on_nameEdit_textChanged(QString str)
{
    emit onServoChange(str,this);
}
